/*
 * Copyright (c) 2015 rmatous.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    rmatous - initial API and implementation and/or initial documentation
 */
package com.tasktop.c2c.server.scm.domain;

import java.io.Serializable;
import org.codehaus.jackson.annotate.JsonCreator;
import org.codehaus.jackson.annotate.JsonProperty;

/**
 *
 * @author rmatous
 */
public class CommitReference implements Serializable {
    //code2cloud.oracle.git
    private final String repository;

    //7c0e55cf006093319694fce4f7857b9c433280e7, master
    private final String revstr;

    //refs/heads/master
    private final String referencePath;

    //means that its supposed such reference already exists
    private final boolean existing;

    @JsonCreator
    public CommitReference(
            @JsonProperty("repository") final String repository,
            @JsonProperty("revstr") final String revstr,
            @JsonProperty("referencePath") final String referencePath,
            @JsonProperty("existing") final boolean existing) {
        this.repository = repository;
        this.revstr = revstr;
        this.referencePath = referencePath;
        this.existing = existing;
    }

    /**
     * Get the value of referencePath
     *
     * @return the value of referencePath
     */
    public String getReferencePath() {
        return referencePath;
    }

    /**
     * @return the repository
     */
    public String getRepository() {
        return repository;
    }

    /**
     * @return the revstr
     */
    public String getRevstr() {
        return revstr;
    }

    /**
     * @return the existing
     */
    public boolean isExisting() {
        return existing;
    }
}
