/*
 * Copyright (c) 2014 oracle.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    oracle - initial API and implementation and/or initial documentation
 */
package com.tasktop.c2c.server.scm.domain;

import java.util.Date;

public final class ScmRepositoryEvent {

    public static enum EventType {

        /**
         * Add a new repository to the project
         */
        CREATED,
        /**
         * Delete an repository from the project
         */
        DELETED,

        /**
         * Rename repository
         */
        RENAMED
    }

    private Profile author;
    private EventType eventType;
    private Date eventDate;
    private ScmRepository repository;

    public ScmRepositoryEvent() {
    }

    /**
     * @param repository
     * @param eventDate
     * @param profile
     * @param eventType
     */
    public ScmRepositoryEvent(ScmRepository repository, Date eventDate, Profile profile, EventType eventType) {
        this.eventDate = eventDate;
        this.author = profile;
        this.eventType = eventType;
        this.repository = repository;
    }

    public Profile getAuthor() {
        return author;
    }
    
    public void setAuthor(Profile commiter) {
        this.author = commiter;
    }

    public EventType getEventType() {
        return eventType;
    }

    public Date getEventDate() {
        return eventDate;
    }

    public void setEventDate(Date eventDate) {
        this.eventDate = eventDate;
    }

    public void setEventType(EventType eventType) {
        this.eventType = eventType;
    }  
    
    public ScmRepository getRepository() {
        return repository;
    }

    public void setRepository(ScmRepository repository) {
        this.repository = repository;
    }
}
